//=======================================================
// Denis Troshin <weiv@mail.ru>
// Subject: Problem with setting ListView styles
//
// Compiler: Digital Mars C/C++ 8.26n
//
// sc -c testmars2.c
// link -SU:WINDOWS testmars2,,,kernel32+user32+gdi32+comctl32,,testmars2.res
//
//=======================================================
#include <windows.h>
#include <commctrl.h>

//Global variables
HINSTANCE hinst;
/*icons for listview's imagelist*/
HICON     hicon1, hicon2;
HWND      hlistview;
/*normal icon and small icon imagelists for listview*/
HIMAGELIST himagelist, himagelist2;
/*---------------------------------------------------*/
#define ID_OK            1
#define ID_BTNICON       101
#define ID_BTNSMALLICON  102
#define ID_BTNLIST       103
#define ID_BTNREPORT     104
#define ID_LISTVIEW1     105
/*---------------------------------------------------*/
/*DIALOGBOX */
int MyDboxProc(HWND, UINT, WPARAM, LPARAM);

int Process_WM_INITDIALOG_D1(HWND hwnd, WPARAM wParam, LPARAM lParam);
int Process_WM_CLOSE_D1(HWND hwnd, WPARAM wParam, LPARAM lParam);
int Process_WM_COMMAND_D1(HWND hwnd, WPARAM wParam, LPARAM lParam);

/*LISTVIEW*/
void ListView_MyAddItem(HWND hlistview, UINT mask, int iItem, int iSubItem, UINT state, UINT stateMask, LPTSTR pszText, int cchTextMax, int iImage, LPARAM lParam);
void ListView_MySetItem(HWND hlistview, UINT mask, int iItem, int iSubItem, UINT state, UINT stateMask, LPTSTR pszText, int cchTextMax, int iImage, LPARAM lParam);
void ListView_MyInsertColumn(HANDLE hlistview, UINT mask, int fmt, int cx, LPTSTR pszText, int cchTextMax, int iSubItem);
/*sets listview columns width (autosize)*/
void PROC_2(HWND hlistview);

/*---------------------------------------------------*/

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{

hinst=hInstance;
InitCommonControls();
DialogBoxParam(hinst, MAKEINTRESOURCE(1), 0, (DLGPROC)MyDboxProc, 0);

return 0;
}
/*============================================================================*/
/*========================================*/
int MyDboxProc(HWND hwnd, UINT mycode, WPARAM wParam, LPARAM lParam)
{
 switch(mycode)
 {
  case WM_INITDIALOG:
   return Process_WM_INITDIALOG_D1(hwnd, wParam, lParam);
  case WM_CLOSE:
   return Process_WM_CLOSE_D1(hwnd, wParam, lParam);
  case WM_COMMAND:
   return Process_WM_COMMAND_D1(hwnd, wParam, lParam);
  default:
   return FALSE;
 }
}
/*========================================*/
int Process_WM_INITDIALOG_D1(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
int i;
char outstr[20];
long tmp_gwl=0, tmp=0;

 hlistview=GetDlgItem(hwnd, ID_LISTVIEW1);

/*Icons for listview's imagelist*/
 hicon1=LoadIcon(hinst, MAKEINTRESOURCE(1));
 hicon2=LoadIcon(hinst, MAKEINTRESOURCE(2));  //unchecked

/*creates imagelist for listview(big_icons)*/
 himagelist=ImageList_Create(32, 32, ILC_MASK, 0, 2);
 ImageList_AddIcon(himagelist, hicon1);

/*creates imagelist for listview(small_icons)*/
 himagelist2=ImageList_Create(16, 16, ILC_MASK, 0, 2);
 ImageList_AddIcon(himagelist2, hicon2);
 
 ListView_SetImageList(hlistview, himagelist2, LVSIL_SMALL);


 /*hlistview, mask, fmt, cx, pszText, cchTextMax, iSubItem*/
 ListView_MyInsertColumn(hlistview, LVCF_TEXT | LVCF_SUBITEM, 0, 0, "Col 1", 0, 0);
 ListView_MyInsertColumn(hlistview, LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT, LVCFMT_RIGHT, 0, "Col2", 0, 1);
 ListView_MyInsertColumn(hlistview, LVCF_TEXT | LVCF_SUBITEM, 0, 0, "Col 3", 0, 2);
 ListView_MyInsertColumn(hlistview, LVCF_TEXT | LVCF_SUBITEM, 0, 0, "Col 4", 0, 3);

for (i=0; i<10; i++)
{
 wsprintf(outstr, "%d", i);
 /*hlistview, mask, iItem, iSubItem, state, stateMask, pszText, cchTextMax, iImage, lParam*/
 ListView_MyAddItem(hlistview, LVIF_TEXT | LVIF_PARAM | LVIF_IMAGE, i, 0, 0, 0, outstr, 0, 0, 0);
 ListView_MySetItem(hlistview, LVIF_TEXT, i, 1, 0, 0, "Subitem 1", 0, 0, 0);
 ListView_MySetItem(hlistview, LVIF_TEXT, i, 2, 0, 0, "Subitem 2", 0, 0, 0);
 ListView_MySetItem(hlistview, LVIF_TEXT, i, 3, 0, 0, "Subitem 3", 0, 0, 0);
}
 /* Sets listview columns width*/
 PROC_2(hlistview);

 return TRUE;
}
/*========================================*/
int Process_WM_CLOSE_D1(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
 DeleteObject(hicon1);
 DeleteObject(hicon2);
 EndDialog(hwnd, 0);
 return TRUE;
}
/*========================================*/
int Process_WM_COMMAND_D1(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
long tmp_gwl=0;
char mystr[20];

if (LOWORD(wParam)==ID_OK)
{
 EndDialog(hwnd, 0);
 return TRUE;
}
else if ( LOWORD(wParam)>=ID_BTNICON  && LOWORD(wParam)<=ID_BTNREPORT )
{
/*retrieves current listview style*/
 tmp_gwl=GetWindowLong(hlistview, GWL_STYLE);
 tmp_gwl=tmp_gwl & ~LVS_TYPEMASK;
 
 switch (LOWORD(wParam))
 {
  case ID_BTNICON:
   tmp_gwl=tmp_gwl | LVS_ICON;
   SetWindowLong(hlistview, GWL_STYLE, tmp_gwl);
   ListView_SetImageList(hlistview, himagelist, LVSIL_NORMAL);
   break;
  case ID_BTNSMALLICON:
   tmp_gwl=tmp_gwl | LVS_SMALLICON;
   SetWindowLong(hlistview, GWL_STYLE, tmp_gwl);
   ListView_SetImageList(hlistview, himagelist2, LVSIL_SMALL);
   break;
  case ID_BTNLIST:
   tmp_gwl=tmp_gwl | LVS_LIST;
   SetWindowLong(hlistview, GWL_STYLE, tmp_gwl);
   ListView_SetImageList(hlistview, himagelist2, LVSIL_SMALL);
   break;
  case ID_BTNREPORT:
   tmp_gwl=tmp_gwl | LVS_REPORT;
   SetWindowLong(hlistview, GWL_STYLE, tmp_gwl);
   ListView_SetImageList(hlistview, himagelist2, LVSIL_SMALL);
   break;
  default:
   return FALSE;   
 }
 tmp_gwl=GetWindowLong(hlistview, GWL_STYLE);
 wsprintf(mystr, "%X", tmp_gwl);
 MessageBox(hwnd, mystr, "new style", 0);
}
else return FALSE;
 
return TRUE;
} /*end of Process_WM_COMMAND_D1*/
/*========================================*/
void ListView_MyInsertColumn(HANDLE hlistview, UINT mask, int fmt, int cx, LPTSTR pszText, int cchTextMax, int iSubItem)
{
LV_COLUMN mylvcolumn;

ZeroMemory(&mylvcolumn, sizeof(LV_COLUMN));

mylvcolumn.mask=mask;
mylvcolumn.fmt=fmt;
mylvcolumn.cx=cx;
mylvcolumn.pszText=pszText;
mylvcolumn.cchTextMax=cchTextMax;
mylvcolumn.iSubItem=iSubItem;
ListView_InsertColumn(hlistview, iSubItem, &mylvcolumn);

return;
}
/*============================================================================*/
void PROC_2(HWND hlistview)
{
unsigned long tmp_gwl=0;

tmp_gwl=GetWindowLong(hlistview, GWL_STYLE);

if ((tmp_gwl & 3)==LVS_REPORT) /*only if current listview style includes LVS_REPORT*/
{
 ListView_SetColumnWidth(hlistview, 0, LVSCW_AUTOSIZE_USEHEADER);
 ListView_SetColumnWidth(hlistview, 1, LVSCW_AUTOSIZE_USEHEADER);
 ListView_SetColumnWidth(hlistview, 2, LVSCW_AUTOSIZE_USEHEADER);
 ListView_SetColumnWidth(hlistview, 3, LVSCW_AUTOSIZE_USEHEADER);
}
return ;
}
/*============================================================================*/
/*============================================================================*/
void ListView_MyAddItem(HWND hlistview, UINT mask, int iItem, int iSubItem, UINT state, UINT stateMask, LPTSTR pszText, int cchTextMax, int iImage, LPARAM lParam)
{
LV_ITEM mylvitem;

ZeroMemory(&mylvitem, sizeof(LV_ITEM));

mylvitem.mask=mask;
mylvitem.iItem=iItem;
mylvitem.iSubItem=iSubItem;
mylvitem.state=state;
mylvitem.stateMask=stateMask;
mylvitem.pszText=pszText;
mylvitem.cchTextMax=cchTextMax;
mylvitem.iImage=iImage;
mylvitem.lParam=lParam;
ListView_InsertItem(hlistview, &mylvitem);

return ;
}
/*============================================================================*/
/*============================================================================*/
void ListView_MySetItem(HWND hlistview, UINT mask, int iItem, int iSubItem, UINT state, UINT stateMask, LPTSTR pszText, int cchTextMax, int iImage, LPARAM lParam)
{
LV_ITEM mylvitem;

ZeroMemory(&mylvitem, sizeof(LV_ITEM));

mylvitem.mask=mask;
mylvitem.iItem=iItem;
mylvitem.iSubItem=iSubItem;
mylvitem.state=state;
mylvitem.stateMask=stateMask;
mylvitem.pszText=pszText;
mylvitem.cchTextMax=cchTextMax;
mylvitem.iImage=iImage;
mylvitem.lParam=lParam;
ListView_SetItem(hlistview, &mylvitem);

return ;
}
/*============================================================================*/
